#!/usr/bin/perl
# CGI frontend for the kicker program
#
# Written By Matt Mets in 2007
# This program is released into the public domain
#
# Some Perl help from:
# http://homepages.paradise.net.nz/milhous/cgi.htm

# Board definitions (todo: offload these to a file...)
@board_names = (
    "Board connected to output #1",
    "Board connected to output #2",
    "Board connected to output #3",
    "Board connected to output #4",
    "Board connected to output #5",
    "Board connected to output #6",
    "Board connected to output #7",
    "Board connected to output #8");

# Location of the kicker executable
$kicker = "/home/matt/projects/cyberkicker/kicker";

# Split the inputs passed by GET into a Hash
@values = split(/&/, $ENV{'QUERY_STRING'});
foreach $i (@values) {
    ($varname, $mydata) = split(/=/, $i);
    $get_vars{$varname} = $mydata;
}

$board = $get_vars{'board'};
$time = $get_vars{'time'};
$action = $get_vars{'action'};


# Header
print <<EndOfHeader;
Content-type: text/html\n\n
<html>
<head><title>CyberKicker: Reset a test board!</title></head>\n
<body>\n
EndOfHeader

# Execute page
if( $action eq "yes" ) {
    print( "Executing kicker program:<br>" );
    $result = system( $kicker, $board, $time );
    print <<EndOfExecute
<form action="test.cgi" method="get">
<input type="submit" name="action" value="return">
</form>
EndOfExecute
}

# Conformation page
elsif( $action eq "confirm" ) {
    if( ($board < 1) || ($board > 8) ) {
        print( "Invalid board specified; Redirececting..." );
        print( "<meta http-equiv=refresh content=\"2; url=test.cgi\">" );
    }
    print <<EndOfConfirm;
Lack of confidence: Really reset `@board_names[$board - 1]`?\n
<form action="test.cgi" method="get">
<input type="hidden" name="board" value="$board">
<input type="hidden" name="time" value="$time">
<input type="submit" name="action" value="yes">
<input type=\"submit" name="action" value="no">
</form>
EndOfConfirm
}


# Start page 
else {
    print "Please choose the board to reset:\n";
    print "<form action=\"test.cgi\" method=\"get\">";
    for( $i=1; $i<9; $i++ ) {
        print "<input type=\"radio\" name=\"board\" value=\"$i\">";
        print "@board_names[$i-1]\n";
        print "</input><br>";
    }
    print <<EndOfStart
Pulse Time(s):<input type="text" name="time" value="2" size="5">
<input type="hidden" name="action" value="confirm">
<input type="submit" value="Reset the board!">
</form>
EndOfStart
}

# Footer
print "</body></html>";
